/**
 * @file
 * Base trigger file for spritespin.js.
 */

(function($) {
  Drupal.behaviors.spritespinColorboxInit = {
    attach: function(context, settings) {
      var a = $('a.spritespin-colorbox-open'),
          id = a.data('spritespin-id');
          currentSettings = Drupal.settings.spritespin[id];

      a.bind('click', function(event) {
        if (currentSettings.width == 0) {
          var screenWidth = (window.innerWidth > 0) ? window.innerWidth : screen.width;
          if (screenWidth <= currentSettings.images_max_width) {
            currentSettings.width = screenWidth - 20;
          }
          else {
            currentSettings.width = currentSettings.images_max_width;
          }
        }

        if (currentSettings.height == 0) {
          var screenHeight = (window.innerHeight > 0) ? window.innerHeight : screen.height;
          if (screenHeight <= currentSettings.images_max_height) {
            currentSettings.height = screenHeight - 50;
          }
          else {
            currentSettings.height = currentSettings.images_max_height;
          }
        }

        containerId = 'spritespin-wrapper-' + id;
        var containerHtml = '<div id="'+ containerId +'"></div>';
        var container;
        $.colorbox({
          html: containerHtml,
          innerWidth: currentSettings.width,
          innerHeight: currentSettings.height,
          onComplete: function() {
            container = $('#'+containerId);
            container.spritespin({
              source: currentSettings.images,
              width: currentSettings.width,
              height: currentSettings.height,
              // reverse interaction direction
              sense: -1,
              sizeMode: 'fit',
              // detectSubsampling: true,
              animate: true,
              loop: false,
              frameTime: 50,
              responsive: true,
              plugins: [
                // 'swipe',
                'progress',
                'drag',
                // 'ease',
                '360',
              ],
              onDraw: function(e, data) {
                // $.colorbox.resize();
              },
              onComplete: function(e, data) {
                // $.colorbox.resize();
              }
            });
          },
          onCleanup: function() {
            container.spritespin('destroy');
            container.html('');
            container.attr('style', '');
          }
        });

        return false;
      });

    }
  };

})(jQuery);